SystemOrganization addCategory: #'Magritte-Core-Description'!
SystemOrganization addCategory: #'Magritte-Core-Builder'!
SystemOrganization addCategory: #'Magritte-Core-Tests'!

TestCase subclass: #MAAbstractTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Tests'!

Object subclass: #MABuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 00:58'!
buildFor: anObject
	^self buildFor: anObject within: anObject container.! !

!MABuilder methodsFor: 'actions' stamp: 'lr 3/10/2005 00:58'!
buildFor: anObject within: aContainer
	anObject class allSelectors do: [ :each |
		(self isDescriptionSelector: each)
			ifTrue: [ aContainer append: (self perform: each) ] ].
	^aContainer.! !

!MABuilder methodsFor: 'testing' stamp: 'lr 3/9/2005 22:42'!
isDescriptionSelector: aSelector
	^aSelector isUnary 
		and: [ aSelector ~= #description ] 
		and: [ aSelector beginsWith: #description ].! !

MABuilder subclass: #MACachedBuilder
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Builder'!

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/9/2005 22:48'!
buildFor: anObject within: aContainer
	^self cache
		at: anObject
		ifAbsentPut: [ super buildFor: anObject within: aContainer ].! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache
	^cache! !

!MACachedBuilder methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:46'!
cache: aDictionary
	cache := aDictionary! !

!MACachedBuilder methodsFor: 'actions' stamp: 'lr 3/9/2005 22:49'!
flushCache
	self cache: IdentityDictionary new.! !

!MACachedBuilder methodsFor: 'initialize-release' stamp: 'lr 3/9/2005 22:47'!
initialize
	super initialize.
	self flush.! !

Object subclass: #MADescription
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MADescription subclass: #MAContainer
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
add: aDescription
	self remove: aDescription.
	self children add: aDescription.! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
append: anObject
	(anObject isKindOf: MADescription)
		ifTrue: [ self add: anObject ]
		ifFalse: [ 
			anObject isCollection
				ifTrue: [ self addAll: anObject ] ].! !

!MAContainer methodsFor: 'adding' stamp: 'lr 3/9/2005 22:52'!
remove: aDescription
	self children remove: aDescription ifAbsent: [ ].! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:27'!
defaultDefault
	^nil! !

!MADescription class methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2005 18:33'!
defaultLabel
	^nil! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/9/2005 18:33'!
descriptionKey
	^MASymbolDescription key: #key label: 'Key' priority: 100 default: self defaultKey.! !

!MADescription class methodsFor: 'accessing-description' stamp: 'lr 3/9/2005 18:33'!
descriptionLabel
	^MAStringDescription key: #label label: 'Label' priority: 110 default: self defaultLabel.! !

!MADescription class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:03'!
isConcrete
	^true! !

!MADescription class methodsFor: 'instance creation' stamp: 'lr 3/9/2005 18:29'!
new
	"Create a new instance of the receiving class and checks if it is concrete."

	self isConcrete
		ifFalse: [ self error: self name , ' is abstract.' ].
	^super new.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 3/9/2005 18:04'!
= aDescription
	^self key = aDescription key.! !

!MADescription methodsFor: 'comparing' stamp: 'lr 3/9/2005 18:04'!
hash
	^self key hash.! !

!MADescription methodsFor: 'initialize-release' stamp: 'lr 3/9/2005 17:58'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/9/2005 18:02'!
key
	self subclassResponsibility.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/9/2005 18:02'!
label
	self subclassResponsibility.! !

!MADescription methodsFor: 'accessing' stamp: 'lr 3/9/2005 18:00'!
properties
	^properties! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/9/2005 18:00'!
propertyAt: aKey
	^self properties at: aKey.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/9/2005 18:00'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsentPut: aBlock.! !

!MADescription methodsFor: 'accessing-properties' stamp: 'lr 3/9/2005 18:01'!
propertyAt: aKey put: aValue
	^self properties at: aKey put: aValue.! !

MADescription subclass: #MAElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MADate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MADate class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

MAElement subclass: #MANumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MANumber class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

MAElement subclass: #MAOptions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAOptions subclass: #MABoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MABoolean class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

MAOptions subclass: #MASelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MASelection class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

MAElement subclass: #MAString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAString subclass: #MAPassword
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MAString class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:14'!
isConcrete
	^true! !

MAString subclass: #MASymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAString subclass: #MAText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

MAElement subclass: #MATime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Core-Description'!

!MATime class methodsFor: 'testing' stamp: 'lr 3/9/2005 18:15'!
isConcrete
	^true! !

!Object class methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:39'!
description
	self subclassResponsibility.! !

!Object methodsFor: '*Magritte-Core' stamp: 'lr 3/9/2005 22:24'!
description
	"Return the description of the reciever. Subclasses might override this message to return instance-based descriptions."
	
	^self class description.! !
